/**
 * All the scripts needed for the events custom post type
 */
 
class SGC_EventGroup {

    constructor( jQuery ) {
        SGC_EventGroup.$ = jQuery;
        
        SGC_EventGroup.eventid = SGC_EventGroup.$('#sgc_eventid').val();
        SGC_EventGroup.groups = [];
        
        SGC_EventGroup.get_groups( SGC_EventGroup.$ );
    }

    /**
     * 
     */
    static display( $ ) {
        // Clear the grouplist
        $('#sgc_eventgroups').html('<h4>Groups:</h4>');
        
        // Loop through the group array and build the group dialogs
        for (var i = 0; i < SGC_EventGroup.groups.length; i++) {
            // Create the group container
            $('#sgc_eventgroups')
                    .append('<div class="sgc_eventgroup" id="sgc_eventgroup_' + i + '" '
                            + '" style="display: inline-block"></div>');

            // Add the group Heading
            if ( SGC_EventGroup.groups[i].name != '' ) {
                $('#sgc_eventgroup_' + i)
                        .append('<div class="sgc_eventgroup_name">'
                                + SGC_EventGroup.groups[i].name
                                + '</div>');
            } else {
                $('#sgc_eventgroup_' + i)
                        .append('<div class="sgc_eventgroup_name">'
                                + '<h5>Group #' + eval( i + 1 ).toString().padStart(2, '0') + '</h5>'
                                + '</div>');
            }
            // Add the group body
            $('#sgc_eventgroup_' + i)
                    .append('<div class="sgc_eventgroup_players" id="sgc_eventgroup_' + i + '_players">'
                            + '<ul id="sgc_eventgroup_' + i + '_players"></ul>'
                            + '</div>');

            // Populate the group body
            if (SGC_EventGroup.groups[i].players.length > 0) {
                for (var j = 0; j < SGC_EventGroup.groups[i].players.length; j++) {
                    $('ul[id=sgc_eventgroup_' + i + '_players]')
                        .append('<li class="sgc_eventgroup_players">'
                            + '<a href="' + SGC.playerurl + '/' + SGC_EventGroup.groups[i].players[j].url + '">' + SGC_EventGroup.groups[i].players[j].name + '</a>'
                            + '</li>');
                }
            } else {
                $('ul[id=sgc_eventgroup_' + i + '_players]')
                        .append('<li class="sgc_eventgroup_players">TBD</li>');
            }
        }
    }
    
    /**
     * 
     */
    static get_groups( $ ) {
        // fetch group JSON array from REST
        $.getJSON(SGC.siteurl + '/wp-json/simplegolfclub/v1/event/groups/' + SGC_EventGroup.eventid, function (result) {
            if ( result != 'null' && result != null ) {
                try {
                    SGC_EventGroup.groups = JSON.parse(result);
                } catch (e) {
                    console.log('not a valid json string');
                }
            }
        }).done(function () {
            if ( SGC_EventGroup.groups != null && SGC_EventGroup.groups.length > 0 ) {
                SGC_EventGroup.display( $ ); 
            } 
        });
    }
    
}
